<?php
/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels - ???
 *          nataliacesario - 07/06/2011 - Implementacao do metodo para retorno do numero da organizacao de
 *          trabalho do operador - nrOrgTrabalho().
 *
 */
class Parametros{

    const PROC_CALCULO = 'CALCULO';
    const PROC_CALCULO_PARCIAL = 'PARCIAL';
    const PROC_SIMULACAO = 'SIMULACAO';
    const PROC_RETROCESSO = 'RETROCESSO';
    const PROC_COMPETENCIA_MENSAL = 'COMPETENCIA_MENSAL';
    const PROC_COMPETENCIA_13 = 'COMPETENCIA_13';

    private $_parametrosOper;
    private $_parametrosOrg;

    private $_nrOrg;
    private $_cdOperador;
    private $_tpModCalculo;
    private $_tpModSalario;

    private static $_instance;

    public function getInstance($nrOrg, $cdOperador) {
        if(self::$_instance === null) {
            self::$_instance = new Parametros($nrOrg, $cdOperador);
        }

        return self::$_instance;
    }

    /**
     * Construtor - Cria instancia de GpeparamoperEntity e carrega os parametros do operador em um atributo da classe.
     *
     * @param string $nrOrg      Numero da organizacao do operador logado.
     * @param string $cdOperador Codigo do operador logado.
     *
     * @author alessandrobartels - ???
     *         alessandrobartels - 08/06/2011 - Retorna da base os parametros do operador.
     */
    public function __construct($nrOrg, $cdOperador){
        $this->_parametrosOper = new GpeparamoperEntity();
        $this->_nrOrg = $nrOrg;
        $this->_cdOperador = $cdOperador;
        $paramOper = $this->_parametrosOper->retornaParametrosOperador($nrOrg, $cdOperador);
        if ($paramOper === false) {
//            tk_warning('Parametros do Operador nao cadastrado.');
            // @todo Criar parametro padrao para Operador
        }
        $this->_parametrosOrg = new GpeparamorgEntity();
        $nrOrg = $this->getNrOrgTrabalho();
        $paramOrg = $this->_parametrosOrg->retornaParamOrganizacao($nrOrg);
        if ($paramOrg === false) {
            tk_warning('Parametros da Organizacao nao cadastrado.');
            // @todo Criar parametro padrao para Org
        }


        $this->_tpModCalculo = new FpaTpmodalidcalEntity();
        $this->_tpModSalario = new FpaTpmodalidsalEntity();
        /* $this->calculo_folha = new FpacalculofolhaEntity(); //verificar */
    }

//==================  IMPLEMENTACAO FUTURA  =========================
    /**
     * Enter description here ...
     *
     * @param string $nrOrg      Numero da organizacao do operador logado.
     * @param string $cdOperador Codigo do operador logado.
     *
     * @return void
     */
    public function carregaParametros($nrOrg, $cdOperador) {
        $this->_parametrosOper->retornaParametrosOperador($nrOrg, $cdOperador);
        $this->_parametrosOrg->retornaParamOrganizacao($nrOrg);
    }


    /**
     * Enter description here ...
     *
     * @param string $nrOrg      Numero da organizacao do operador logado.
     * @param string $cdOperador Codigo do operador logado.
     *
     * @return void
     */
    public function carregaParametrosOperador($nrOrg, $cdOperador) {
        $this->_parametrosOper->retornaParametrosOperador($nrOrg, $cdOperador);
    }


    /**
     * Enter description here ...
     *
     * @param string $nrOrg Numero da organizacao do operador logado.
     *
     * @return void
     */
    public function carregaParametrosOrg($nrOrg) {
        $this->_parametrosOrg->retornaParamOrganizacao($nrOrg);
    }
//---------------- FIM IMPLEMENTACAO FUTURA ----------------------

    /* ####################### PARAMETROS DO OPERADOR ###################### */


    /**
     * Retorna mes de competencia.
     *
     * @return TkDateTime
     *
     * @author alessandrobartels - 18/04/2011
     *         alessandrobartels - 08/06/2011 - Pega o mes de competencia ja retornado na instancia GpeparamoperEntity
     */
    public function getMesCompetencia(){
        $mesCompetencia = $this->_parametrosOper->retornaMesCompetenciaOperador();
        $mesCompetencia = new TkDateTime($mesCompetencia, TkDateTime::FORMAT_DATE);
        /* Retorna a data para o primeiro dia do mes. */
        $mesCompetencia->setDay(1);
        return $mesCompetencia;
    }


    /**
    * Retorna o numero da organizacao de trabalho do operador.
    *
    * @return integer
    *
    * @author alessandrobartels -
    */
    public function getNrOrgTrabalho(){
        return \Geral\Util\Ambiente::getNrorgTrabalho();
    }

    /**
     * Retorna o código do operador
     * @return string
     * $author pck
     */
    public  function getCdOperador(){
        return $this->_cdOperador;
    }


    /**
    * Retorna o numero da estrutura de trabalho do operador.
    *
    * @return integer
    *
    * @author alessandrobartels -
    */
    public function getNrEstrutTrab($nrorg,$cdoperador){
        //return $this->_parametrosOper->retornaNrEstruturaTrabalho();
        $obj = Gpeparamoper::retornaParamOper($nrorg, $cdoperador);
        if (is_object($obj) === true) {
            return $obj->getNrorgtrab();
        }
    }

    /**
     * Retorna de identificador de debug de regra.
     *
     * @return boolean
     *
     * @author alessandrobartels - 07/12/2011
     */
    public function getIdDebug() {
        return $this->_parametrosOper->retornaIdDebug();
    }


    /**
     * Retorna a data de alteracao salarial. Atribui o primeiro dia do mes de competencia.
     *
     * @param integer $nrorg Numero da Organizacao.
     *
     * @return TkDateTime
     */
    public function dataAlteracaoSalarial($nrorg){
        $dt_alt_salario = new TkDateTime(
            $this->_parametrosOper->retornaMesCompetencia($nrorg), TkDateTime::FORMAT_DATE
        );
        /*  $dt_alt_salario->setDay(1);*/
        return $dt_alt_salario;
    }


    /**
     * Retorna o ambiente de salario do operador.
     *
     * @return string
     *
     * @author alessandrobartels - 18/04/2011
     *         alessandrobartels - 08/06/2011 - Pega o ambiente de salario do operador ja retornado na instancia
     *         									GpeparamoperEntity.
     */
    public function ambienteSalarioOperador() {
        return $this->_parametrosOper->retornaAmbienteSalarioOperador();
    }


    /**
     * Retorna o tipo de modalidade salarial do operador.
     *
     * @return string
     *
     * @author thalesvalias - 12/12/2011
     */
    public function getTipoModalidadeSalario() {
        return $this->_parametrosOper->retornaTipoModalidadeSalario();
    }


    /**
     * Descricao do Tipo de Modalidade de Salario.
     *
     * @return string
     */
    public function getDescricaoTipoModalidadeSalario(){
        $nrTpModSalario = $this->getTipoModalidadeSalario();
        $descricao = $this->_tpModSalario->getDescricaoTipoModalidadeSalario($nrTpModSalario);
        return $descricao;
    }


    /**
     * Retorna o tipo de modalidade de calculo.
     *
     * @return integer
     *
     * @author alessandrobartels - 20/12/2011
     */
    public function getTipoModalidadeCalculo(){
        return $this->_parametrosOper->retornaTipoModalidadeCalculo();
    }


    /**
     * Descricao do Tipo de Modalidade de Calculo.
     *
     * @return string
     */
    public function getDescricaoTipoModalidadeCalculo(){
        $nrTpModCalculo = $this->getTipoModalidadeCalculo();
        $descricao = $this->_tpModCalculo->getDescricaoTipoModalidadeCalculo($nrTpModCalculo);
        return $descricao;
    }


    /**
     * Retorna o numero de ocorrencia de calculo.
     *
     * @return integer
     *
     * @author alessandrobartels - 20/12/2011
     */
    public function getNrOcorrenciaCalculo(){
        return $this->_parametrosOper->retornaNrOcorrenciaCalculo();
    }


    /**
     * Retorna tipo de operador.
     *
     * @return string
     *
     * @author alessandrobartels - 26/03/2012
     */
    public function getTipoOperador(){
        $nrOrgPadrao = $this->getNrOrgPadrao();
        $nrOrgOperador = $this->_nrOrg;
        return $this->_parametrosOper->retornaTipoOperador($nrOrgOperador, $nrOrgPadrao);
    }


    /* ####################### PARAMETROS DA ORGANIZACAO ###################### */


    /**
     * Enter description here ...
     *
     * @return number
     */
    public function getNrOrgPadrao() {
       /* $nrOrg = $this->getNrOrgTrabalho();
        $obj_paramOrg = $this->_parametrosOrg->retornaParamOrganizacao($nrOrg);

        if ($obj_paramOrg !== null) {
            $nrOrgPadrao = $obj_paramOrg->getNrorgpadrao();
            unset($obj_paramOrg);
            return $nrOrgPadrao;
        } else {
            tk_warning('GPEPARAMORG - Organizacao nao parametrizada.');
        }*/

        return $this->_parametrosOrg->retornaNrOrgPadrao();

    }


    /**
     * Retorna tipo de estrutura por identificador estrutura (LEGAL / GERENCIAL)
     *
     * @param string $idEstrutura Identificador da estrutura.
     *
     * @return Ambigous <nrtpestrutlegal, NULL>
     */
    public function getTipoEstruturaLegal() {
        /*$nrOrg = $this->getNrOrgTrabalho();
        $obj_paramOrg = $this->_parametrosOrg->retornaParamOrganizacao($nrOrg);
        if (strtoupper($idEstrutura) === GpeparamorgEntity::IDESTRUTURA_LEGAL) {
            $nrTpEstrutura = $obj_paramOrg->getNrtpestrutlegal();
        } elseif (strtoupper($idEstrutura) === GpeparamorgEntity::IDESTRUTURA_GERENCIAL) {
            $nrTpEstrutura = $obj_paramOrg->getNrtpestrutgeren();
        } else {
            tk_warning('Parametro de identificador de estrutura nao definido.');
        }

        unset($obj_paramOrg);
        return $nrTpEstrutura;
        */

        return $this->_parametrosOrg->retornaTipoEstruturaLegal();
    }


    public function getTipoEstruturaGerencial() {
        return $this->_parametrosOrg->retornaTipoEstruturaGerencial();
    }




}