/* Sistemas Integrados TEKNISA
  Documentos Fiscais

Nome: 0002_SDXFUNO.SQL

@C:\web_511\sql\end_conv\oracle\clientes\sdx\0002_SDXFUNO_CGCFORCLIE_RNF.sql

Descrio:
Funo para retornar o campo CGCFORCLIE para gerao da RNF de transferncia
de Entrada (Tipo de operao 99 - Transf. Centro de Distribuio)

P_CDTIPOOPER   - Cdigo do tipo de operao.
P_NRINSJURNF   - Inscrio do fornecedor/cliente.

Criao:
01/03/2010 - Fabrcio Marcelo da Silva
*/

CREATE OR REPLACE FUNCTION CGCFORCLIE_RNF(
   P_CDTIPOOPER    IN TIPOOPERAC.CDTIPOOPER%TYPE,
   P_NRINSJURNF    IN NOTAFISCAL.NRINSJURNF%TYPE) RETURN VARCHAR2
AS
   V_CGCFORCLIE  VARCHAR2(20);
BEGIN

   V_CGCFORCLIE := NULL;

   IF P_CDTIPOOPER = '99' THEN
      BEGIN
         SELECT MAX(CDFILIAL)
           INTO V_CGCFORCLIE
           FROM FILIAL
          WHERE NRINSJURFILI = P_NRINSJURNF;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_CGCFORCLIE := NULL;
      END;
   ELSE
      V_CGCFORCLIE := P_NRINSJURNF;
   END IF;

   RETURN(V_CGCFORCLIE);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CGCFORCLIE_RNF','5.05.138'); END;
/

